var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
var xml;
var regionList;
var countryList;
var cityList;

function setup() {
	loadXML('coordinates.xml');

    window.resizeTo(180, 150);
	createGenericButton(document.getElementById('done'), getLocalizedString('Done'), hideBack);
	
	document.getElementById("age_title").innerText = getLocalizedString("Age");
	document.getElementById("loc_title").innerText = getLocalizedString("Loc");
	document.getElementById("rise_title").innerText = getLocalizedString("Rise");
	document.getElementById("set_title").innerText = getLocalizedString("Set");
	
	document.getElementById("lng").title = getLocalizedString("help_lng");
	document.getElementById("lat").title = getLocalizedString("help_lat");
	document.getElementById("canvas").title = getLocalizedString("help_canvas");
	
	if (window.widget) { 
		widget.onshow = onshow; 
		widget.onhide = onhide;
		window.onfocus = onfocus;
		window.onblur = onblur;
	}
}

function onshow () 
{ 
	drawMoon(); 
} 

function onhide () 
{ 
} 

function onfocus() 
{
}

function onblur()
{
	hideInfo();
}

function mouseClick(event)
{
	drawMoon(); 
	showInfo();
}

function loadPreferences()
{
	var lng = widget.preferenceForKey("lng");
	if (lng) {
		document.getElementById("lng").value = lng;
	}
	var lat = widget.preferenceForKey("lat");
	if (lat) {
		document.getElementById("lat").value = lat;
	}
	
	var regionIdx = widget.preferenceForKey("regionPopup");
	if (regionIdx) {
	   	var regionPopup = document.getElementById('region');
	   	regionPopup.options[regionIdx].selected = true;
	   	regionChanged();
		
		var countryIdx = widget.preferenceForKey("countryPopup");
		if (countryIdx) {
		   	var countryPopup = document.getElementById('country');
		   	countryPopup.options[countryIdx].selected = true;
		   	countryChanged();
		   	
		   	var cityIdx = widget.preferenceForKey("cityPopup");
		   	if (cityIdx) {
	    	   	var cityPopup = document.getElementById('city');
	    	   	cityPopup.options[cityIdx].selected = true;
	    	    cityChanged();
	        }
		} 
	}
}

function changePref(id)
{
	var val = document.getElementById(id).value;
	if (window.widget) {
		widget.setPreferenceForKey(val, id);	
	}
}

function showBack()
{
	hideInfo();

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
		widget.prepareForTransition("ToBack");
	}
 
    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);  
  	}
}

function hideBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget) {
        widget.prepareForTransition("ToFront");
 	}
	
    back.style.display = "none";
    front.style.display = "block";
        
    if (window.widget) {
//	   	widget.setPreferenceForKey(countryPopup.selectedIndex, "countryPopup");
//		widget.setPreferenceForKey(cityPopup.selectedIndex, "cityPopup");
   
        setTimeout('widget.performTransition();', 0);
		setTimeout('drawMoon();', 1);
		setTimeout('exitflip();', 2);
    }
}
  
function regionChanged(event)
{
	var regionPopup = document.getElementById('region');
	var countryPopup = document.getElementById('country');
	countryPopup.length = 0;

	var regionName = regionPopup.options[regionPopup.selectedIndex].value;

	if (window.widget) {
		widget.setPreferenceForKey(regionPopup.selectedIndex, "regionPopup");
	}

	if (countryName == "customize") {
		// customize
		
		document.getElementById("lng").disabled = "";
		document.getElementById("lat").disabled = "";

		return;
	}

	countryPopup.options[0] = new Option;
	countryPopup.options[0].innerText = getLocalizedString("select country");
	countryPopup.options[0].disabled = "disabled";

	var idx;
	for (idx = 0; idx < regionList.length; idx++) {
		if (regionList[idx].getAttribute("name") == regionName) {
			countryList = regionList[idx].getElementsByTagName("country");
			break;
		}
	}

	for (idx = 0; idx < countryList.length; idx++) {
		var countryName = countryList[idx].getAttribute("name");
		countryPopup.options[idx + 1] = new Option;
		countryPopup.options[idx + 1].value = countryName;
		countryPopup.options[idx + 1].innerText = getLocalizedString(countryName);
	}
}

function countryChanged(event)
{
	var countryPopup = document.getElementById('country');
	var cityPopup = document.getElementById('city');
	cityPopup.length = 0;

	var countryName = countryPopup.options[countryPopup.selectedIndex].value;

	if (window.widget) {
		widget.setPreferenceForKey(countryPopup.selectedIndex, "countryPopup");
	}

	if (countryName == "customize") {
		// customize
		
		document.getElementById("lng").disabled = "";
		document.getElementById("lat").disabled = "";

		return;
	}

	cityPopup.options[0] = new Option;
	cityPopup.options[0].innerText = getLocalizedString("select city");
	cityPopup.options[0].disabled = "disabled";

	var idx;
	for (idx = 0; idx < countryList.length; idx++) {
		if (countryList[idx].getAttribute("name") == countryName) {
			cityList = countryList[idx].getElementsByTagName("city");
			break;
		}
	}

	for (idx = 0; idx < cityList.length; idx++) {
		var cityName = cityList[idx].getAttribute("name");
		cityPopup.options[idx + 1] = new Option;
		cityPopup.options[idx + 1].value = cityName;
		cityPopup.options[idx + 1].innerText = getLocalizedString(cityName);
	}
}

function cityChanged(event)
{
	var countryPopup = document.getElementById('country');
	var cityPopup = document.getElementById('city');

	if (window.widget) {
		widget.setPreferenceForKey(cityPopup.selectedIndex, "cityPopup");
	}
	
	var idx;
	var city;
	for (idx = 0; idx < cityList.length; idx++) {
		if (cityList[idx].getAttribute("name") == cityPopup.options[cityPopup.selectedIndex].value) {
			city = cityList[idx];
			break;
		}
	}
	
	var lng = city.getElementsByTagName("lng")[0].firstChild.nodeValue;
	var lat = city.getElementsByTagName("lat")[0].firstChild.nodeValue;
	
	document.getElementById("lng").value = lng;
	document.getElementById("lat").value = lat;	
	
	document.getElementById("lng").disabled = "disabled";
	document.getElementById("lat").disabled = "disabled";
}

function loadXML(url)
{
	var req = new XMLHttpRequest();
	req.onreadystatechange = function() {
		if (req.readyState == 4) {
			xml = req.responseXML;
			setupRegionPop();
			
			loadPreferences();
		}
	}
	
	req.open('POST', url, true);
	req.send(0);
}

function setupRegionPop()
{
	var regionPopup = document.getElementById("region");
	regionList = xml.getElementsByTagName("region");
	
    regionPopup.length = 0;
	regionPopup.options[0] = new Option;
	regionPopup.options[0].innerText = getLocalizedString("select region");
	regionPopup.options[0].disabled = "disabled";
	
	var idx;
	for (idx = 0; idx < regionList.length; idx++) {
		var regionName = regionList[idx].getAttribute("name");
		regionPopup.options[idx + 1] = new Option;
		regionPopup.options[idx + 1].value = regionName;
		regionPopup.options[idx + 1].innerText = getLocalizedString(regionName);
	}
	
	regionPopup.options[idx + 1] = new Option;
	regionPopup.options[idx + 1].value = "customize";
	regionPopup.options[idx + 1].innerText = getLocalizedString("customize");
}

